'''
Created on 14.10.2011

@author: ays
'''

from conditionplugin import add_plugin
from artixds.generalfunction.conditionhelper import __timeIn, __dateIn, __dayIn, __getAsList, __hasOptions
from datetime import date,datetime

@add_plugin
def hasClientOptions(self, options = None):
    if not self.card or not self.card["card"] or not self.card["card"]["client"]:
        return False  
    return __hasOptions(options, self.card["card"]["client"]["extendedoptions"])

@add_plugin
def birthdayDate(self, firstDay = None, lastDay = None):
    if not self.card or not self.card["card"] or not self.card["card"]["client"]:
        return False
    currentDate = self.check["datetimebeg"].date()
    birthday = self.card["card"]["client"]["birthday"]
    return __dayIn(currentDate, birthday, firstDay, lastDay)

@add_plugin
def birthdayIn(self, beginTime = None, endTime = None):
    return self.birthdayDate(beginTime, endTime)

@add_plugin
def birthdayDateIn(self, beginDate = None, endDate = None):
    if not self.card or not self.card["card"] or not self.card["card"]["client"]:
        return False
    currentDate = self.check["datetimebeg"].date()
    birthday = self.card["card"]["client"]["birthday"]
    testDate = date(currentDate.year(), birthday.month(), birthday.day())
    return __dateIn(testDate, beginDate, endDate)

@add_plugin
def specialDate(self, firstDay = None, lastDay = None, datename = 'specialdate1'):
    if not self.card or not self.card["card"] or not self.card["card"]["client"]:
        return False
    currentDate = self.check["datetimebeg"].date()
    testDate = self.card["card"]["client"][datename]
    return __dayIn(currentDate, testDate, firstDay, lastDay)

@add_plugin
def specialdayIn(self, beginTime = None, endTime = None, datename = 'specialdate1'):
    return self.specialDate(beginTime, endTime, datename)

@add_plugin
def specialDateIn(self, beginDate = None, endDate = None, datename = 'specialdate1'):
    if not self.card or not self.card["card"] or not self.card["card"]["client"]:
        return False
    currentDate = self.check["datetimebeg"].date()
    _testDate = self.card["card"]["client"][datename]
    testDate = date(currentDate.year(), _testDate.month(), _testDate.day())
    return __dateIn(testDate, beginDate, endDate)

@add_plugin
def isVerificated(self):
    return self.card and not(self.card["verificationtype"] is None)

@add_plugin
def hasVerificationTypes(self, types=list()):
    typeNames = [method["typename"] for method in self.card["card"]["sourcecardgroup"]["verificationmethods"]]

    if not typeNames:
        return False

    for typeName in types:
        if typeName not in typeNames:
            return False

    return True
