'''
Created on 13.08.2010

@author: gsu
'''

import enum
from campaign import DiscountCampaignGroup, DiscountCampaign

class DiscountSystemType(enum.Enum):
    DISCOUNT = enum.Item()
    BONUS = enum.Item()
    BONUSPAY = enum.Item()

class DiscountSystem(object):
    rootCampaignGroup = DiscountCampaignGroup()
    manualCampaigns = []
    def __init__(self, rootCampaignGroup=None, type=DiscountSystemType.DISCOUNT, manualCampaigns = [], number=1):
        self.rootCampaignGroup = rootCampaignGroup
        self.type = type
        self.manualCampaigns = manualCampaigns
        self.number = number

    def getManualCampaignsInfo(self, campaignGroup):
        objects = campaignGroup.discountCampaigns + campaignGroup.childGroups
        result = []
        for obj in objects:
            if isinstance(obj, DiscountCampaign):
                if hasattr(obj,'manualActivate') and obj.manualActivate and obj.isActive():
                    campaignInfo = {}
                    campaignInfo['id'] = obj.id
                    campaignInfo['name'] = obj.name
                    campaignInfo['beginDate'] = obj.beginDate
                    campaignInfo['endDate'] = obj.endDate
                    campaignInfo['beginTime'] = obj.beginTime
                    campaignInfo['endTime'] = obj.endTime
                    campaignInfo['daysOfWeek'] = obj.daysOfWeek
                    campaignInfo['checkedTags'] = obj.checkedTags
                    campaignInfo['tagsIsAllowed'] = obj.tagsIsAllowed
                    if obj.discounts:
                        campaignInfo['discountId'] = obj.discounts[0].id
                    result.append(campaignInfo)
            elif isinstance(obj, DiscountCampaignGroup):
                result.extend(self.getManualCampaignsInfo(obj))
        return result
    
    def loadManualCampaigns(self):
        self.manualCampaigns = self.getManualCampaignsInfo(self.rootCampaignGroup)
