# -*- coding: utf-8 -*-

from conditionhelper import __hasGroups, __hasCatalogs

def countersQuantByBcode(self, idCounter, bcode, percent, limit, calcWhenLessLimit, alwaysCalcDiscount):

    if self.check["countersstatus"] == 2:
        counterSum = self.check["counters"].get(idCounter, 0)
    elif self.check["countersstatus"] == 1:
        if alwaysCalcDiscount:
            if calcWhenLessLimit:
                counterSum = 0
            else:
                counterSum = limit
        else:
            return {}
    else:
        return {}

    positions = {}
    totals = counterSum

    for item in self.checkWrapper.getGoodsList():
        itemBcode = item.data['bcode']

        if itemBcode not in bcode:
            continue

        if calcWhenLessLimit and (totals < limit):
            count = min(item.data['bquant'], limit - totals)
            totals += count
        elif not calcWhenLessLimit:
            if (item.data['bquant'] + totals) > limit:
                count = min(item.data['bquant'] + totals - limit, item.data['bquant'])
                totals += item.data['bquant']
            else:
                totals += item.data['bquant']
                continue
        else:
            continue

        positions[item.data['posnum']] = item.data['price'] * percent / 100.0 * count

    return positions

def countersQuantByCode(self, idCounter, code, percent, limit, calcWhenLessLimit, alwaysCalcDiscount):

    if self.check["countersstatus"] == 2:
        counterSum = self.check["counters"].get(idCounter, 0)
    elif self.check["countersstatus"] == 1:
        if alwaysCalcDiscount:
            if calcWhenLessLimit:
                counterSum = 0
            else:
                counterSum = limit
        else:
            return {}
    else:
        return {}

    positions = {}

    totals = counterSum

    count = 0

    for item in self.checkWrapper.getGoodsList():

        if item.data['code'] not in code:
            continue

        if calcWhenLessLimit and (totals < limit):
            count = min(item.data['bquant'], limit - totals)
            totals += count
        elif not calcWhenLessLimit:
            if (item.data['bquant'] + totals) > limit:
                count = min(item.data['bquant'] + totals - limit, item.data['bquant'])
                totals += item.data['bquant']
            else:
                totals += item.data['bquant']
                continue
        else:
            continue

        positions[item.data['posnum']] = item.data['price'] * percent / 100.0 * count

    return positions

def countersQuantByCatalog(self, idCounter, catalog, percent, limit, calcWhenLessLimit, alwaysCalcDiscount):

    if self.check["countersstatus"] == 2:
        counterSum = self.check["counters"].get(idCounter, 0)
    elif self.check["countersstatus"] == 1:
        if alwaysCalcDiscount:
            if calcWhenLessLimit:
                counterSum = 0
            else:
                counterSum = limit
        else:
            return {}
    else:
        return {}

    positions = {}
    totals = counterSum

    for item in self.checkWrapper.getGoodsList():

        if not __hasCatalogs(catalog, item.data["tmc"]["catalogs"]):
            continue

        if calcWhenLessLimit and (totals < limit):
            count = min(item.data['bquant'], limit - totals)
            totals += count
        elif not calcWhenLessLimit:
            if (item.data['bquant'] + totals) > limit:
                count = min(item.data['bquant'] + totals - limit, item.data['bquant'])
                totals += item.data['bquant']
            else:
                totals += item.data['bquant']
                continue
        else:
            continue

        positions[item.data['posnum']] = item.data['price'] * percent / 100.0 * count

    return positions

def countersQuantByGroup(self, idCounter, group, percent, limit, calcWhenLessLimit, alwaysCalcDiscount):

    if self.check["countersstatus"] == 2:
        counterSum = self.check["counters"].get(idCounter, 0)
    elif self.check["countersstatus"] == 1:
        if alwaysCalcDiscount:
            if calcWhenLessLimit:
                counterSum = 0
            else:
                counterSum = limit
        else:
            return {}
    else:
        return {}

    positions = {}
    totals = counterSum

    for item in self.checkWrapper.getGoodsList():

        if not __hasGroups(group, item.data["tmc"]["tmcgroups"]):
            continue

        if calcWhenLessLimit and (totals < limit):
            count = min(item.data['bquant'], limit - totals)
            totals += count
        elif not calcWhenLessLimit:
            if (item.data['bquant'] + totals) > limit:
                count = min(item.data['bquant'] + totals - limit, item.data['bquant'])
                totals += item.data['bquant']
            else:
                totals += item.data['bquant']
                continue
        else:
            continue

        positions[item.data['posnum']] = item.data['price'] * percent / 100.0 * count

    return positions

def countersQuantByAccumulation(self, idCounter, ranges, defaultIndex):
    
    if self.check["countersstatus"] == 1:
        return defaultIndex
    elif self.check["countersstatus"] != 2:
        return -1
        
    counterValue = self.check["counters"].get(idCounter, 0)
    
    index = 0
    for r in ranges:
        index += 1
        if(not isinstance(r, tuple) or len(r) != 2):
            continue
        
        if(r[0] <= counterValue and (counterValue <= r[1] or r[1] == None)):
            return index
    return -1