# -*- coding: utf-8 -*-

from artixds.objectdiscount import DiscountObject

class KitObjectItem(object):
    '''
    Элемент набора
    '''
    def __init__(self, catalogCodes=None, quantity=1, name=None):
        self.catalogCodes = [] if catalogCodes is None else catalogCodes
        self.name = name
        self.quantity = quantity

    def __repr__(self): 
        return "KitObjectItem(catalogCodes=%s,quantity=%f)" % (self.catalogCodes, self.quantity)

class KitObject(DiscountObject):
    '''
    Новый объект набора
    '''
    def __init__(self, items=None, id=None, name=None, maxtimes=None, byTmc=None):
        self.items = [] if items is None else items
        self.id = id
        self.name = name
        self.maxtimes = maxtimes
        self.byTmc = byTmc

    def __iter__(self):
        for item in self.items:
            yield item

    def __len__(self):
        return len(self.items)

    def __repr__(self):
        return "KitObject(maxtime=%s,items=%s,byTmc=%s)" % (self.maxtimes, self.items, self.byTmc)

