# -*- coding: utf-8 -*-
'''
Created on 16.06.2010

@author: adm
'''
from artixds.domain import DiscountCampaignGroup, DiscountCampaign, DiscountCondition, DiscountCardCondition, DiscountSystem
from artixds.domain import Discount 
from artixds.domain import Kit, KitItem, CheckObject, PositionObject, KitObject, KitObjectItem
from artixds.domain import PercentDiscountRate, KitDiscountRate, KitDiscountRateItem
from artixds.domain import InteractionType
from datetime import date
from sqlalchemy.orm import mapper
from artixds.mapper import DiscountSystemData, discountSystemTable
from sqlalchemy.orm import sessionmaker
from sqlalchemy import create_engine
import yaml
from artixds.discountsystem import DiscountSystemType


def NahodkaBonus():

    bs = DiscountSystem()
    grp = DiscountCampaignGroup(id=7, name='Находка Бонус')
    bonusCampaign = DiscountCampaign(name="Бонусная компания", id=1, interactionType=InteractionType.MAX, beginDate=date(2010, 8, 1))
    bonusCampaign.discounts = [ Discount(campaign=bonusCampaign, 
                                        name="бонус 30%",
                                        objects=[CheckObject({})], 
                                        conditions=[ ], 
                                        discountRate=PercentDiscountRate(0.30), id=101) ]
    bonusCampaign.parentGroup = grp

    bs.rootCampaignGroup = grp

    return bs

def NahodkaBonusPay():

    bs = DiscountSystem()
    grp = DiscountCampaignGroup(id=7, name='Находка Оплата Бонус')
    bonusCampaign = DiscountCampaign(name="Бонусная компания", id=1, interactionType=InteractionType.MAX, beginDate=date(2010, 8, 1))
    bonusCampaign.discounts = [ Discount(campaign=bonusCampaign, 
                                        name="бонус 30%",
                                        objects=[CheckObject({})], 
                                        conditions=[ ], 
                                        discountRate=PercentDiscountRate(0.30), id=101) ]
    bonusCampaign.parentGroup = grp

    bs.rootCampaignGroup = grp

    return bs

def NahodkaDiscount11():

    ds = DiscountSystem()

    grp = DiscountCampaignGroup(id=7, name='Новэкс')
    maleCampaign = DiscountCampaign(name="23 февраля", id=1, interactionType=InteractionType.MAX, beginDate=date(2010,2,23), endDate=date(2010,2,23))
    maleCampaign.discounts = [ Discount(campaign=maleCampaign, 
                                        name="23 февраля - 20%",
                                        objects=[PositionObject({})], 
                                        conditions=[ 
                                        DiscountCardCondition('card["card"]["client"]["sex"]==0') 
                                        ], 
                                        discountRate=PercentDiscountRate(20.0), id=101) ]
    maleCampaign.parentGroup = grp

    femaleCampaign = DiscountCampaign(name="8 матра", id=2, interactionType=InteractionType.MAX, beginDate=date(2010,3,8), endDate=date(2011,3,8))
    femaleCampaign.discounts = [ Discount(campaign=femaleCampaign,
                                          name="8 марта - 25%",
                                          objects=[PositionObject({})], 
#                                         conditions=[ DiscountCardCondition('card["card"]["client"]["sex"]==1') ],
                                          conditions=[ ],
                                          discountRate=PercentDiscountRate(25.0), id=201) ]
    femaleCampaign.parentGroup = grp

    kitCampaign = DiscountCampaign(name="Скидка на количество", id=6, interactionType=InteractionType.ALL)
    kit = Kit(name="Купи набор, тройной - бесплатно", items=[
                                                                               KitItem(codes=['00037'], quantity=2),
                                                                               KitItem(codes=['00037'], quantity=3) ], id=789)
    kitCampaign.discounts = [ Discount(campaign=kitCampaign,
                                       id=345,
                                       objects=[kit],
                                       name="скидка на комплект",
                                       conditions=[],
                                       discountRate=KitDiscountRate(items=[
#                                                                           KitDiscount("10043", 2, PercentDiscountRate(0.00)),
                                                                           KitDiscountRateItem(kit.items[1], PercentDiscountRate(100))]))]
    kitCampaign.parentGroup = grp

    grp.interactionType = InteractionType.MAX
    grp.discountCampaigns = [ maleCampaign, femaleCampaign, kitCampaign ]

    ds.rootCampaignGroup = grp

    return ds

def NahodkaDiscount():

    ds = DiscountSystem()

    grp = DiscountCampaignGroup(id=7, name='Находка')
    pinkCampaign = DiscountCampaign(name="Розовая карта", id=1, interactionType=InteractionType.MAX, beginDate=date(2010, 8, 1))
    pinkCampaign.discounts = [ Discount(campaign=pinkCampaign, 
                                        name="розовая карта",
                                        objects=[PositionObject({})], 
                                        conditions=[ DiscountCardCondition('card["card"]["idcardgroup"]==1') ], 
                                        discountRate=PercentDiscountRate(0.01), id=101) ]
    pinkCampaign.parentGroup = grp

    socialCampaign = DiscountCampaign(name="Социальная карта", id=2, interactionType=InteractionType.MAX)
    socialCampaign.discounts = [ Discount(campaign=socialCampaign,
                                          name="социальная карта",
                                          objects=[PositionObject({})], 
                                          conditions=[ DiscountCondition('datetime.now().time() >= time(9, 0)'),
                                                       DiscountCondition('datetime.now().time() >= time(9, 0)'),
                                                       DiscountCondition('datetime.now().weekday() in [0,1,2,3,4]'),
                                                       DiscountCardCondition('card["card"]["idcardgroup"]==2') ],
                                          discountRate=PercentDiscountRate(0.10), id=201) ]
    socialCampaign.parentGroup = grp

    silverCampaign = DiscountCampaign(name="Серебряная карта", id=3, interactionType=InteractionType.MAX)
    silverCampaign.discounts = [ Discount(campaign=silverCampaign,
                                          name="серебряная карта больше 10000", 
                                          objects=[PositionObject({})], 
                                          conditions=[ DiscountCardCondition('card["card"]["cardsum"]>=10000'),
#                                                       DiscountCondition('check["cardrecords"][0]["cardgroup"]["idcardgroup"]==3') ],
                                                       DiscountCardCondition('card["card"]["cardgroup"]["idcardgroup"]==3') ],
                                          discountRate=PercentDiscountRate(0.07), id=301),
                                 Discount(campaign=silverCampaign, 
                                          name="серебряная карта меньше 10000",
                                          objects=[PositionObject({})], 
                                          conditions=[ DiscountCardCondition('card["card"]["idcardgroup"]==3'),
#                                                       DiscountCondition('check["cardrecords"][0]["card"]["idcardgroup"]==3'),
                                                       DiscountCardCondition('card["card"]["cardsum"]<10000') ],
                                          discountRate=PercentDiscountRate(0.05), id=302) ]
    silverCampaign.parentGroup = grp

    freshCampaign = DiscountCampaign(name="Карта фреш", id=4, interactionType=InteractionType.MAX)
    freshCampaign.discounts = [ Discount(campaign=freshCampaign,
                                          name="карта фреш", 
                                          objects=[PositionObject({})], 
                                          conditions=[ DiscountCardCondition('card["card"]["idcardgroup"]==4') ],
                                          discountRate=PercentDiscountRate(0.05), id=401) ]
    freshCampaign.parentGroup = grp

    luckyHourCampaign = DiscountCampaign(name="Счастливый час", id=5, interactionType=InteractionType.ALL)
    luckyHourCampaign.discounts = [ Discount(campaign=luckyHourCampaign, 
                                          objects=[PositionObject({'bcode':'1055'})], 
                                          name="счастливый час для 1055",
                                          conditions=[ DiscountCondition('datetime.now().time() >= time(10, 0) and datetime.now().time() <= time(14, 0)') ],
                                          discountRate=PercentDiscountRate(0.50), id=501),
                                    Discount(campaign=luckyHourCampaign, 
                                          name="счастливый час для 10020", 
                                          objects=[PositionObject({'bcode':'10020'})], 
                                          conditions=[ DiscountCondition('datetime.now().time() >= time(10, 0) and datetime.now().time() <= time(14, 0)') ],
                                          discountRate=PercentDiscountRate(0.70), id=502) ]
    luckyHourCampaign.parentGroup = grp

    kitCampaign = DiscountCampaign(name="Скидка на количество", id=6, interactionType=InteractionType.ALL)
    kit = Kit(name="При покупке 2x цезарей и 1го винигрета скидка 10%", items=[
                                                                               KitItem(code='10027', qty=1),
                                                                               KitItem(code='10020',qty=3),
                                                                               KitItem(code='10020',qty=1) ], id=789)
    kitCampaign.discounts = [ Discount(campaign=kitCampaign,
                                       id=345,
                                       objects=[kit],
                                       name="скидка на салаты",
                                       conditions=[],
                                       discountRate=KitDiscountRate(value=[
                                                                           KitDiscount("10027", 1, PercentDiscountRate(0.05)),
                                                                           KitDiscount("10020", 3, PercentDiscountRate(0.10)),
                                                                           KitDiscount("10020", 1, PercentDiscountRate(0.50)) ]) ) ]
    kitCampaign.parentGroup = grp

    grp.interactionType = InteractionType.ALL
    grp.discountCampaigns = [ pinkCampaign, socialCampaign, silverCampaign, freshCampaign, luckyHourCampaign, kitCampaign ]

    ds.rootCampaignGroup = grp

    return ds

                                                                                              

def createRootCampaignGroup1():
 
    cam = DiscountCampaign(name="Не покупай кефир по карте, а покупай в правильное время!", id=1001)
    cam.discounts = []
#    cam.beginDate = date(2010, 5, 30)
#    cam.endDate = date(2010, 6 , 30)
    
#    discount0 = Discount(cam)
#    discount0.objects = [Check({})]
#    discount0.conditions = [DiscountCondition(condition='check["sum1"]>200')]
#    discount0.discountRate = PercentDiscountRate(0.1)
#    cam.discounts.append(discount0)
    
    
    discount1 = Discount(cam, id=1)
    discount1.objects = [PositionObject({"bcode":"10020"})]
    discount1.conditions = [DiscountCondition(condition='check["sum1"]>200')]
    discount1.discountRate = PercentDiscountRate(0.1)
    cam.discounts.append(discount1)
     
    discount2 = Discount(cam, id=2)
    kit = Kit()
    
    kit.name = "При покупке 2x морож. и хлеба скидка 10% "
    kitItem = KitItem()
    kitItem.code = "10027"
    kitItem.qty = 2
    kitItem2 = KitItem()
    kitItem2.code = "10020"
    kitItem2.qty = 1
    kit.items = [kitItem, kitItem2]
    discount2.objects = [kit]
    kitDiscountRate = KitDiscountRate()
    kitDItem = KitDiscount("10027", 2, PercentDiscountRate(0.05))
    kitDItem2 = KitDiscount("10020", 1, PercentDiscountRate(0.10))
    kitDiscountRate.value = [kitDItem, kitDItem2]
    discount2.discountRate = kitDiscountRate
    cam.discounts.append(discount2)
#    
    
    discount3 = Discount(cam, id=3)
    kit = Kit()
    
    kit.name = "При покупке 3x морож. и хлеба скидка 30% "
    kitItem = KitItem()
    kitItem.code = "10027"
    kitItem.qty = 3
    kitItem2 = KitItem()
    kitItem2.code = "10020"
    kitItem2.qty = 1
    kit.items = [kitItem, kitItem2]
    kitDiscountRate = KitDiscountRate()
    kitDItem = KitDiscount("10027", 3, PercentDiscountRate(0.3))
    kitDItem2 = KitDiscount("10020", 1, PercentDiscountRate(0.10))
    kitDiscountRate.value = [kitDItem, kitDItem2]
    discount3.discountRate = kitDiscountRate
    discount3.objects = [kit]
    cam.discounts.append(discount3)
    
   
    cam.interactionType = InteractionType.MIN
    
    group = DiscountCampaignGroup()
    group.interactionType = InteractionType.MAX
    group.discountCampaigns = [cam] 
    
    return group



def createGroup1(groupRoot):
    
    subGroup = DiscountCampaignGroup()
    subGroup.name = "Салатный день"
    subGroup.interactionType = InteractionType.ALL
    subGroup.discountCampaigns = []
    
    groupRoot.childGroups.append(subGroup)
    
    createCam1_1(subGroup)
    
    createCam1_2(subGroup)
    
def createCam1_1(groupRoot):
    subCampaing = DiscountCampaign(id=1002)
    subCampaing.name = "Салатик"
    subCampaing.interactionType = InteractionType.ALL
    groupRoot.discountCampaigns.append(subCampaing)
    subCampaing.discounts = []
    
    discount1 = Discount(subCampaing, id=11)
    discount1.objects = [PositionObject({"code":"10027"})]
    discount1.conditions = [DiscountCondition(condition='check["sum1"]>200')]
    discount1.discountRate = PercentDiscountRate(0.05)
    subCampaing.discounts.append(discount1)
    
    discount1 = Discount(subCampaing, id=121)
    discount1.objects = [PositionObject({"code":"10020"})]
    discount1.conditions = [DiscountCondition(condition='check["sum1"]>200')]
    discount1.discountRate = PercentDiscountRate(0.1)
    subCampaing.discounts.append(discount1)
    
def createCam1_2(groupRoot):
    subCampaing = DiscountCampaign(id=1003)
    subCampaing.name = "Салат 2 плюс не салат 1"
    subCampaing.interactionType = InteractionType.ALL
    groupRoot.discountCampaigns.append(subCampaing)
    subCampaing.discounts = []
    
    kit = Kit()
    discount2 = Discount(subCampaing, id=12)
    kit.name = "При покупке 2x цезарей. и 1 одного венигрета 10% "
    kitItem = KitItem()
    kitItem.code = "10027"
    kitItem.qty = 2
    kitItem2 = KitItem()
    kitItem2.code = "10020"
    kitItem2.qty = 1
    kit.items = [kitItem, kitItem2]
    discount2.objects = [kit]
    kitDiscountRate = KitDiscountRate()
    kitDItem = KitDiscount("10027", 2, PercentDiscountRate(0.05))
    kitDItem2 = KitDiscount("10020", 1, PercentDiscountRate(0.10))
    kitDiscountRate.value = [kitDItem, kitDItem2]
    discount2.discountRate = kitDiscountRate
    subCampaing.discounts.append(discount2)


def createCam0(groupRoot):
    subCampaing = DiscountCampaign(id=1004)
    subCampaing.name = "Зелень"
    subCampaing.interactionType = InteractionType.ALL
    subCampaing.discounts = []
    
    groupRoot.discountCampaigns.append(subCampaing)
    
    discount1 = Discount(subCampaing, id=27)
    discount1.objects = [PositionObject({"code":"10027"}),PositionObject({"code":"10020"})]
    discount1.conditions = [DiscountCondition(condition='check["sum1"]>200')]
    discount1.discountRate = PercentDiscountRate(0.15)
    subCampaing.discounts.append(discount1)
    
    
    kit = Kit()
    discount2 = Discount(subCampaing, id=28)
    kit.name = "При покупке 2x цезарей. и 1 одного винигрета 10% "
    kitItem = KitItem()
    kitItem.code = "10027"
    kitItem.qty = 1
    kitItem2 = KitItem()
    kitItem2.code = "10020"
    kitItem2.qty = 3
    kit.items = [kitItem, kitItem2]
    discount2.objects = [kit]
    kitDiscountRate = KitDiscountRate()
    kitDItem = KitDiscount("10027", 1, PercentDiscountRate(0.05))
    kitDItem2 = KitDiscount("10020", 3, PercentDiscountRate(0.10))
    kitDiscountRate.value = [kitDItem, kitDItem2]
    discount2.discountRate = kitDiscountRate
    subCampaing.discounts.append(discount2)
    

def createRootCampaignGroup2():
  
    groupRoot = DiscountCampaignGroup()
    groupRoot.name = "Родительская группа"
    groupRoot.interactionType = InteractionType.ALL
    groupRoot.discountCampaigns = []
    groupRoot.childGroups = []
    
    createCam0(groupRoot)
    
    createGroup1(groupRoot)
    
    return groupRoot

def createGroup2(groupRoot):
    
    subGroup = DiscountCampaignGroup()
    subGroup.name = "Группа 2"
    subGroup.interactionType = InteractionType.MAX
    subGroup.discountCampaigns = []
    
    groupRoot.childGroups.append(subGroup)
    
    createCam1_1(subGroup)
    
    createCam1_2(subGroup)
    
def createGroup3(groupRoot):
    
    subGroup = DiscountCampaignGroup()
    subGroup.name = "Группа 3"
    subGroup.interactionType = InteractionType.ALL
    subGroup.discountCampaigns = []
    
    groupRoot.childGroups.append(subGroup)
    
    createCam0(subGroup)
    



def createRootCampaignGroup3():
    groupRoot = DiscountCampaignGroup()
    groupRoot.name = "Родительская группа"
    groupRoot.interactionType = InteractionType.MAX
    groupRoot.discountCampaigns = []
    groupRoot.childGroups = []
    
    createGroup2(groupRoot)
    
    createGroup3(groupRoot)
    
    return groupRoot


def createCam4_0(groupRoot):
    subCampaing = DiscountCampaign(id=1005)
    subCampaing.name = "Зелень"
    subCampaing.interactionType = InteractionType.ALL
    subCampaing.discounts = []
    
    groupRoot.discountCampaigns.append(subCampaing)
    
 
    kit = Kit()
    discount2 = Discount(subCampaing, id=29)
    kit.name = "При покупке 2x цезарей. и 1 одного винигрета 10% "
    kitItem = KitItem()
    kitItem.code = "10027"
    kitItem.qty = 1
    kitItem2 = KitItem()
    kitItem2.code = "10020"
    kitItem2.qty = 3
    kitItem3 = KitItem()
    kitItem3.code = "10020"
    kitItem3.qty = 1
    kit.items = [kitItem, kitItem2,kitItem3]
    discount2.objects = [kit]
    kitDiscountRate = KitDiscountRate()
    kitDItem = KitDiscount("10027", 1, PercentDiscountRate(0.05))
    kitDItem2 = KitDiscount("10020", 3, PercentDiscountRate(0.10))
    kitDItem3 = KitDiscount("10020", 1, PercentDiscountRate(0.50))
    kitDiscountRate.value = [kitDItem, kitDItem2,kitDItem3]
    discount2.discountRate = kitDiscountRate
    subCampaing.discounts.append(discount2)

def createRootCampaignGroup4():
    groupRoot = DiscountCampaignGroup()
    groupRoot.name = "Родительская группа"
    groupRoot.interactionType = InteractionType.MAX
    groupRoot.discountCampaigns = []
    groupRoot.childGroups = []
    createCam4_0(groupRoot)
    return groupRoot

def loadDiscountSystem(session, discSys, secondDiscSys, bonSys, bon1Sys, update_time = None):
    resultTime = None	
    discountSystems = session.query(DiscountSystemData).all()
    for sys in discountSystems:
    	if not update_time or sys.update_time != update_time:	
            if sys.discsystem:
                discSys.rootCampaignGroup = yaml.load(sys.discsystem)
                discSys.loadManualCampaigns()
                discSys.number = 1
            else:
                discSys.rootCampaignGroup = None
                discSys.manualCampaigns = []
            if sys.seconddiscsystem:
                secondDiscSys.rootCampaignGroup = yaml.load(sys.seconddiscsystem)
                secondDiscSys.loadManualCampaigns()
                secondDiscSys.number = 2
            else:
                secondDiscSys.rootCampaignGroup = None
                secondDiscSys.manualCampaigns = []
            if sys.bonusearnsystem:
                bonSys.rootCampaignGroup = yaml.load(sys.bonusearnsystem)
            else:
                bonSys.rootCampaignGroup = None
                bonSys.manualCampaigns = []
            if sys.bonuslimitsystem:
                bon1Sys.rootCampaignGroup = yaml.load(sys.bonuslimitsystem)
            else:
                bon1Sys.rootCampaignGroup = None
                bon1Sys.manualCampaigns = []
            resultTime = sys.update_time
    return resultTime if resultTime else update_time

def getDiscountUpdateTime(session):
    discountSystems = session.query(DiscountSystemData.update_time).all()
    for sys in discountSystems:
        return sys.update_time
    return None

def loadDiscountSystemLegacy():
    mapper(DiscountSystemData, discountSystemTable) 
    engine = create_engine('mysql://root@localhost/dictionaries', echo=True)
    Session = sessionmaker(autoflush=True, autocommit=True)
    Session.configure(bind=engine)
    session = Session()
    discSys, bonSys, bonpSys = None, None, None
    discountSystems = session.query(DiscountSystemData).all()
    for sys in discountSystems:
        discSys = DiscountSystem()
        discSys.rootCampaignGroup = yaml.load(sys.discsystem)
    return discSys, bonSys, bonpSys

def loadDiscountSystemSimple():
    mapper(DiscountSystemData, discountSystemTable) 
    engine = create_engine('mysql://root@localhost/dictionaries', echo=True)
    Session = sessionmaker(autoflush=True, autocommit=True)
    Session.configure(bind=engine)
    session = Session()
    discSys, bonSys, bonpSys = None, None, None
    discountSystems = session.query(DiscountSystemData).all()
    for sys in discountSystems:
        discSys = DiscountSystem()
        discSys.rootCampaignGroup = yaml.load(sys.discsystem)
    return discSys, bonSys, bonpSys

def createSession():
    mapper(DiscountSystemData, discountSystemTable) 
    engine = create_engine('mysql://root@localhost/dictionaries', echo=True)
    Session = sessionmaker(autoflush=True, autocommit=True)
    Session.configure(bind=engine)
    return Session()
	
session = createSession()
  
#discountSystem, bonusEarnSystem, bonusLimitSystem = loadDiscountSystem()
