# -*- coding: utf-8 -*-
'''
Created on 03.02.2011

@author: gsu
'''

import json
from discountmanager import DiscountManager, KitManager, DiscountCollection, Discount, DiscountMode
#from check import Check
from checktotals import CheckTotals, DiscountObjectForCheck
from os import path
import jsonpickle
import logging.config
from log_decorator import log_after
from bunch import Bunch
from discountrate import PercentDiscountRate

try:
    logging.config.fileConfig('/linuxcash/cash/discountsystems/log.ini')
except:
    logging.basicConfig()

logger = logging.getLogger('su.artix.dm')

km = KitManager()


def refreshSystems():
	pass

@log_after
def encodeResult(d, b):
    return jsonpickle.encode([ [ q.toDict() for q in d ], b ])

@log_after
def calculateImpact(check, config):
    totals = CheckTotals(check, config)
    dm = DiscountManager(totals)
    km.extractKits(totals)
    b, d = km.discounts(totals)
    d.extend(dm.discount(check))
    for card in check.getCardsList():
        d.extend(dm.discountByCard(check, card))
        
    return b,d

@log_after
def calculateDiscountImpact():
    logger.debug('entering calculateDiscountImpact')
    check = artix_core.check
    totals = CheckTotals(check, artix_core.config)
    dm = DiscountManager(totals)
    km.extractKits(totals)
    b, d = km.discounts(totals)
    d.extend(dm.discount(check))
    logger.debug('there are %d cards in check found' % len(check.getCardsList()))
    for card in check.getCardsList():
        logger.info("scanning for card '%s'" % card.getCardObject().number)
        d.extend(dm.discountByCard(check, card))
    res = encodeResult(d, b)
    logger.debug('result is %s' % (res))
    return res

def calculateBonusEarningsImpact():
    return None

def calculateBonusLimitImpact():
    check = artix_core.check
    totals = CheckTotals(check, artix_core.config)
    dobj = DiscountObjectForCheck(check)
    rate = PercentDiscountRate(100)
    rate.scheme = Bunch(code=0, name=u'')
    rate.disccode = 0
    rate.name = ''
    return encodeResult(DiscountCollection([Discount(dobj, dobj, dobj, rate, None, DiscountMode.AUTOMATIC)]), [])

def calculateDiscountImpactTest(test_check, test_config):
    check = test_check
    totals = CheckTotals(check, test_config)
    dm = DiscountManager(totals)
    km.extractKits(totals)
    b, d = km.discounts(totals)
    d.extend(dm.discount(check))
    for card in check.getCardsList():
        d.extend(dm.discountByCard(check, card))
    res = encodeResult(d, b)
    return res    	
	
if __name__ == '__main__':

    ck = u'check.json'
    if path.isfile(ck):
        logger.info('have test check object! running test pass...')
        calculateDiscountImpact(open(ck, 'r').read())
        logger.info('test pass done')
    logger.info('leagcy discount system successfully loaded')
