#!/usr/bin/python
# -*- coding: utf-8 -*-
'''
Created on 09.07.2010

@author: adm
'''

import yaml
import logging
import logging.config

from artixds.domain import DiscountSystem
from subsystem import Subsystem
from dao import loadDiscountSystem
from dao import session
from dao import getDiscountUpdateTime

try:
    logging.config.fileConfig('/linuxcash/cash/discountsystems/logging.properties')
except Exception, e:
    print u'logger configure error: `%s`' % e
    logging.basicConfig()

discountSystem, secondDiscountSystem, bonusEarnSystem, bonusLimitSystem = DiscountSystem(), DiscountSystem(), DiscountSystem(), DiscountSystem()
time_update = loadDiscountSystem(session, discountSystem, secondDiscountSystem, bonusEarnSystem, bonusLimitSystem)

log = logging.getLogger("su.artix.dm")

log.debug(u'Первая дисконтная система:')
for n, line in enumerate(filter(lambda x: x.rstrip(), yaml.dump(discountSystem).split('\n'))):
    log.debug(u'%4d: %s' % (n, line.rstrip()))
log.debug(u'Вторая дисконтная система:')
for n, line in enumerate(filter(lambda x: x.rstrip(), yaml.dump(secondDiscountSystem).split('\n'))):
    log.debug(u'%4d: %s' % (n, line.rstrip()))
log.debug(u'Начисление бонусов:')
for n, line in enumerate(filter(lambda x: x.rstrip(), yaml.dump(bonusEarnSystem).split('\n'))):
    log.debug(u'%4d: %s' % (n, line.rstrip()))
log.debug(u'Списание бонусов:')
for n, line in enumerate(filter(lambda x: x.rstrip(), yaml.dump(bonusLimitSystem).split('\n'))):
    log.debug(u'%4d: %s' % (n, line.rstrip()))

def refreshSystems():
    global time_update
    global manualCampaigns
    old_time_update = time_update
    log.debug(u'Обновление дисконтной системы')
    time_update = loadDiscountSystem(session, discountSystem, secondDiscountSystem, bonusEarnSystem, bonusLimitSystem, time_update)
    Subsystem(discountSystem).refreshTagsValid()
    Subsystem(secondDiscountSystem).refreshTagsValid()
    Subsystem(bonusEarnSystem).refreshTagsValid()
    Subsystem(bonusLimitSystem).refreshTagsValid()
    return old_time_update != time_update

def isUpToDate():
    global time_update
    return time_update != None and getDiscountUpdateTime(session) == time_update

def calculateDiscountImpact():
    return Subsystem(discountSystem).quickInJson(artix_core_check)

def calculateSecondDiscountImpact():
    return Subsystem(secondDiscountSystem).quickInJson(artix_core_check)

def calculateBonusEarningsImpact():
    return Subsystem(bonusEarnSystem).quickInJson(artix_core_check)

def calculateBonusLimitImpact():
    return Subsystem(bonusLimitSystem).quickInJson(artix_core_check)

def getCampaigns():
    return Subsystem().encode(discountSystem.manualCampaigns)

def getSecondDiscountSystemCampaigns():
    return Subsystem().encode(secondDiscountSystem.manualCampaigns)
